
Base Language - Bug #7484

decimal format - left-side 'balance' must include group separators

07/05/2023 01:08 PM - Constantin Asofiei

Status: Test Start date:  

Priority: Normal Due date:  

Assignee: Constantin Asofiei % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

billable: No case_num:  

vendor_id: GCD   

Description

History

#2 - 07/05/2023 01:11 PM - Constantin Asofiei

This format is valid in OE: ->,>>>,>>9.9<<<<<<<<.

We have logic in NumberType.parseFormat which computes a leftBalance, but this is not incremented for the group separator.  Including the group

separator solves the issue.

The recreate is this:

def var h as handle.

create temp-table h.

h:add-new-field("f1", "decimal", ?, "->,>>>,>>9.9<<<<<<<<").

 

The fix is as simple as this:

      for(; i < len; i++)

      {

         switch (fmt.charAt(i))

         {

         case '>':

            leftBalance++;

            digits++;

            leftDigitFmt += fmt.charAt(i);

            break;

         case FORMAT_GROUP_SEP:

            leftBalance++;            // <!--------------- include the group separator

            leftSeps++; 

            break;

         default:

            break endLeftSection;

         }

      }
#3 - 07/07/2023 01:52 PM - Greg Shah

Is the problem that an error 22 is raised in FWD but not in OE?

What happens in the case where there is a mixture of > and other digit types (9, z, Z, *)?

#4 - 07/07/2023 02:35 PM - Constantin Asofiei

Greg Shah wrote:

Is the problem that an error 22 is raised in FWD but not in OE?

 

Correct.

What happens in the case where there is a mixture of > and other digit types (9, z, Z, *)?

 

Only the > and , (group sep) from left-side are balanced with the right-side <.  The other 9, z, Z, * are not included in this balance.

#5 - 07/07/2023 02:37 PM - Greg Shah

What happens in the case where there is a mixture of > and other digit types (9, z, Z, *)?

 

Only the > and , (group sep) from left-side are balanced with the right-side <.  The other 9, z, Z, * are not included in this balance.

 

In the 4GL?  I know that is how the FWD code is written.  I'm just wondering if the 4GL considers all the group seps in the case where some left side

digits are not >.

#6 - 07/07/2023 02:43 PM - Constantin Asofiei

Greg Shah wrote:
What happens in the case where there is a mixture of > and other digit types (9, z, Z, *)?

 

Only the > and , (group sep) from left-side are balanced with the right-side <.  The other 9, z, Z, * are not included in this balance.

 

In the 4GL?

 

Correct, I've tested now in 4GL.

I'm just wondering if the 4GL considers all the group seps in the case where some left side digits are not >.

 

As far as I can tell only the group sep characters and > are considered from left-side.  But I've tested the group-sep on the right-side - this can be

used, and is also included in the 'balance' for the right-side.

#7 - 07/07/2023 02:45 PM - Greg Shah

OK, go ahead with the change.

#8 - 07/07/2023 03:09 PM - Constantin Asofiei

- Status changed from New to Review

- Assignee set to Constantin Asofiei

- % Done changed from 0 to 100

Created task branch 7484a from trunk rev 14648.  The fix is in rev 14649.

#9 - 07/07/2023 03:47 PM - Greg Shah

Code Review Task Branch 7484a Revision 14649

No objections.

#10 - 07/11/2023 11:51 AM - Greg Shah

Go ahead with merge.
#11 - 07/11/2023 11:59 AM - Constantin Asofiei

7484a was merged to trunk rev 14650 and archived.

#12 - 07/11/2023 01:28 PM - Greg Shah

- Status changed from Review to Test
